(**********************************************
	COMS W4115 PLT - 2014 Spring Term Project
	HL-HDL compiler: scanner.mll
		Name:	Woon Lee
		UNI:	wgl2107
***********************************************)

{ open Parser }

let letter = ['a'-'z' 'A'-'Z']
let digit = ['0'-'9']
let bidigit = ['0' '1']
let hexdigit = ['0'-'9' 'a'-'f' 'A'-'F']

rule token =
	parse [' ' '\n' '\t' '\r'] { token lexbuf }
		| eof { EOF }				
		| "insig"		{ INSIG }	| "outsig"		{ OUTSIG }
		| "iosig"		{ IOSIG }	| "constant" 	{ CONST } 	
		| "signal" 		{ SIGNAL }	| "and" 		{ AND }
		| "or" 			{ OR }		| "inv"			{ INV }
		| "buf"			{ BUF }		| "lat"			{ LAT }
		| "mux" 		{ MUX }		
		| "func" 		{ FUNC }	| "if"			{ IF }
		| "then"		{ THEN }	| "else"		{ ELSE }
		| "main" 		{ MAIN }	| ','			{ COMMA }
		| '('			{ LPAREN }	| ')'			{ RPAREN }
		| '{'			{ LBRACE }	| '}'			{ RBRACE }
		| '['			{ LBRACKET } | ']'			{ RBRACKET }
		| ';'			{ SEMI }	| ':'			{ COLON }
		| letter (letter | digit | '_')* as id 	{ ID(id) }
		| digit+ as lit 						{ INUM(int_of_string lit) }
		| "0b" bidigit+ as bdigit				{ BNUM(bdigit) }
		| "0x" hexdigit+ as hdigit				{ HNUM(hdigit) }
		| "=="			{ EQ }		| "!="		{ NEQ }
		| '='			{ ASSIGN }	| ":="		{ IASSIGN }
		| "/*" 			{ comment lexbuf }
		| _ { raise (Failure("Unrecognized token: " ^ Lexing.lexeme lexbuf)) }

and comment = 
	parse "*/" {token lexbuf }
		| _ { comment lexbuf }