----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY test4_top_tb is

end ENTITY test4_top_tb;

ARCHITECTURE behavioral of test4_top_tb is

COMPONENT test4_top is
port (
	clk : in  std_logic;
	rst : in  std_logic;
	strobe1 : in  std_logic;
	strobe2 : in  std_logic;
	addr : in std_logic_vector(2 downto 0);
	data_out : out std_logic_vector(7 downto 0)
);
end COMPONENT;

	signal clk :  std_logic;
	signal rst :  std_logic;
	signal strobe1 :  std_logic;
	signal strobe2 :  std_logic;
	signal addr : std_logic_vector(2 downto 0);
	signal data_out : std_logic_vector(7 downto 0);
	signal sim_done : boolean := false;

begin

inst_test4_top : test4_top
	port map(
		clk => clk,
		rst => rst,
		strobe1 => strobe1,
		strobe2 => strobe2,
		addr => addr,
		data_out => data_out
	);

clk_proc : process 
	begin
		if (not sim_done) then
			clk <= '0';
			wait for 20 ns;
			clk <= '1';
			wait for 20 ns;
		else
			report "sim_done";
			wait; --wait forever
		end if;
	end process clk_proc;

input_proc : process
	begin
		strobe1 <= '0';
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "000";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "001";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "010";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "011";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "100";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "101";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "110";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait for 30 ns;
		strobe1 <= '1';
		addr <= "111";
		wait for 10 ns;
		strobe2 <= '1';
		wait for 30 ns;
		strobe1 <= '0';
		wait for 5 ns;
		strobe2 <= '0';
		
		wait;
	end process;

sim_time : process
	begin
		rst <= '1';
		wait for 10 ns;
		rst <= '0';
		wait for 600 ns;
		sim_done <= true;
		wait;
	end process;

end;

