----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

package globals is

-- Constants and global signals declaration

-- Components declaration
component addr_decode is
port (
	rst : in  std_logic;
	cs : in  std_logic;
	oe : in  std_logic;
	we : in  std_logic;
	addr : in std_logic_vector(1 downto 0);
	rd_strobe : out std_logic_vector(3 downto 0);
	wr_strobe : out std_logic_vector(3 downto 0)
);
end component addr_decode;

end globals;


-- Entities and architectures of the components
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY addr_decode is
port (
	rst : in  std_logic;
	cs : in  std_logic;
	oe : in  std_logic;
	we : in  std_logic;
	addr : in std_logic_vector(1 downto 0);
	rd_strobe : out std_logic_vector(3 downto 0);
	wr_strobe : out std_logic_vector(3 downto 0)
);
end addr_decode;

architecture RTL of addr_decode is
	signal rd_str :  std_logic;
	signal wr_str :  std_logic;
	signal strobe : std_logic_vector(3 downto 0);
begin
	rd_str <= cs AND oe;
	wr_str <= cs AND we;

	proc_rst_cond : process (all)
	begin
	if rst = '1' then
	rd_strobe <= x"0";
	wr_strobe <= x"0";
	else
	if addr = "00" then
	rd_strobe(0) <= rd_str;
	rd_strobe(3 downto 1) <= "000";
	wr_strobe(0) <= wr_str;
	wr_strobe(3 downto 1) <= "000";
	else
	if addr = "01" then
	rd_strobe(0) <= '0';
	rd_strobe(1) <= rd_str;
	rd_strobe(3 downto 2) <= "00";
	wr_strobe(0) <= '0';
	wr_strobe(1) <= wr_str;
	wr_strobe(3 downto 2) <= "00";
	else
	if addr = "10" then
	rd_strobe(1 downto 0) <= "00";
	rd_strobe(2) <= rd_str;
	rd_strobe(3) <= '0';
	wr_strobe(1 downto 0) <= "00";
	wr_strobe(2) <= wr_str;
	wr_strobe(3) <= '0';
	else
	rd_strobe(2 downto 0) <= "000";
	rd_strobe(3) <= rd_str;
	wr_strobe(2 downto 0) <= "000";
	wr_strobe(3) <= wr_str;
	end if;
	end if;
	end if;
	end if;
	end process;

end RTL;

configuration CFG_addr_decode of addr_decode is
	for RTL
	end for;
end CFG_addr_decode;



